import * as generate from "./generate";
import * as derive from "./derive";
import * as utils from "./utils";
import { sign, signAndSubmit } from "./sign";
import * as rawSigning from "./rawSigning";
import XRPL_Account from "./schema/Account";
import { XrplClient } from "xrpl-client";
import * as rippleKeypairs from "ripple-keypairs";
import * as xrplBinaryCodecPrerelease from "xrpl-binary-codec-prerelease";
import { XrplDefinitions, nativeAsset } from "xrpl-binary-codec-prerelease";
import { type DefinitionsData } from "xrpl-binary-codec-prerelease/dist/enums/xrpl-definitions-base";
declare const binary: {
    encode: typeof xrplBinaryCodecPrerelease.encode;
    decode: typeof xrplBinaryCodecPrerelease.decode;
    encodeForSigning: typeof xrplBinaryCodecPrerelease.encodeForSigning;
    encodeForMultisigning: typeof xrplBinaryCodecPrerelease.encodeForMultisigning;
    encodeForSigningClaim: typeof xrplBinaryCodecPrerelease.encodeForSigningClaim;
};
declare const libraries: {
    rippleAddressCodec: any;
    rippleKeypairs: typeof rippleKeypairs;
    rippleSecretCodec: any;
    xrplBinaryCodecPrerelease: typeof xrplBinaryCodecPrerelease;
    rippleBinaryCodec: typeof xrplBinaryCodecPrerelease;
};
export { XRPL_Account, generate, derive, sign, signAndSubmit, utils, rawSigning, XrplDefinitions, binary, XrplClient, nativeAsset, libraries, };
export type { DefinitionsData };
