export declare enum AccountTypes {
    Passphrase = "passphrase",
    FamilySeed = "familySeed",
    Mnemonic = "mnemonic",
    Hex = "hex",
    SecretNumbers = "secretNumbers"
}
export declare type KeyPair = {
    algorithm?: Algorithms | null;
    publicKey?: string | null;
    privateKey: string | null;
};
export declare type Algorithms = "ed25519" | "secp256k1";
export interface AccountOptions {
    accountType?: AccountTypes;
    address?: string;
    passphrase?: string;
    familySeed?: string;
    secretNumbers?: string[];
    mnemonic?: string;
    path?: string;
    keypair?: KeyPair;
    algorithm?: Algorithms;
}
export default class XRPL_Account {
    accountType: AccountTypes | null;
    address: string | null;
    secret: {
        familySeed: string | null;
        mnemonic: string | null;
        passphrase: string | null;
        path: string | null;
        secretNumbers: string[] | null;
    };
    keypair: KeyPair;
    _signAs?: any;
    constructor(options?: AccountOptions);
    signAs(address: string): this;
    toString(): string;
}
