import { XrplDefinitions } from "xrpl-binary-codec-prerelease";
import Account from "../schema/Account";
import { XrplClient } from "xrpl-client";
declare type SignedObject = {
    type: "SignedTx" | "MultiSignedTx" | "SignedPayChanAuth";
    id: string;
    signedTransaction: string;
    txJson: Record<string, unknown>;
    signers: string[];
};
declare const setNativeAsset: (Tx: any) => void;
declare const sign: (transaction: Object, account?: Account | Account[] | undefined, definitions?: XrplDefinitions | undefined) => SignedObject;
declare const signAndSubmit: (transaction: Object, client: XrplClient | string, account: Account | Account[]) => Promise<{
    tx_blob: string;
    tx_id: string;
    response: import("xrpl-client").AnyJson;
}>;
export { sign, signAndSubmit, setNativeAsset };
export type { SignedObject };
export default sign;
